unit ufDateTime;

interface
uses sysUtils, cDateTime, cStrings, ufGeneral;

  Function FileDateTimeToSchemaDateTime(const FileDate : integer; TimeZone: integer) : String;

implementation

Function FileDateTimeToSchemaDateTime(const FileDate : integer; TimeZone: integer) : String;
var
  dt: TDateTime; Ye, Mo, Da, Ho, Mi, Se, Ml : Word;
begin
  dt:= FileDateToDateTime(FileDate);
  DecodeDateTime (dt, Ye, Mo, Da, Ho, Mi, Se, Ml);
  Result := IntToStr(Ye)+'-'+PadLeft(IntToStr(Mo),'0', 2)+'-'+PadLeft(IntToStr(Da),'0', 2);
  Result := Result+'T'+PadLeft(IntToStr(Ho),'0', 2)+':'+PadLeft(IntToStr(Mi),'0', 2)+':'+PadLeft(IntToStr(Se),'0', 2);
  if TimeZone = 0 then
    Result := 'Z'
  else
  begin
    if (TimeZone > 0) then
      Result := Result+'+'
    else if (TimeZone < 0) then
      Result := Result+'-';
    Result := Result+PadLeft(IntToStr(Abs(TimeZone)),'0', 2)+':00';
  end;
end;
end.
