
//==================================================================================================
//CyExcel is a Multi-Sheet Electron Grid Component ,it Develope Base XLGrid 1.6
//XLGrid1.6ĻʵֵĶҳӱؼ
//==================================================================================================
//Author : yvtong@citiz.net
//Version : 0.1 ( for Delphi6 )
//Last Edit : 11:00 2003-1-10
//Bug:
//   Dpk  Sheets Editorгͻ
//ToDo:
//  ͨ ColLabelStyleǷʾкŻк
//==================================================================================================

unit CyExcel;

interface
uses
  Classes,Windows,Messages,SysUtils ,Graphics ,Contnrs ,
  Controls,Extctrls,Tabs,Buttons,StdCtrls,Menus,
  XLGrids ,XLStream;
ResourceString
  SHEET_CAPTION='Sheet';
  DELETE_ERROR = 'Delete Error !';
type
  { declared ahead }
  TCySheetTabSet = class ;
  TCyExcel = class ;
  TCyCustomSheet = class ;
  TCyStyler = class ;
  TCySheets = class ;

  TCyVisibleOption = (voSheetNav,voSheetTabSet,voScrollBar );//,voRowLabel,voColLabel);
  TCyVisibleOptions = Set of TCyVisibleOption ;
  TCySheetType = (Normal,DataAWare);

  TColLabelStyle= (csNum,csLetter);

  TCyCustomSheet = class(TXLCustomSheet)
  private
    FHint: string;
    FCaption: TCaption;
    FSheetType: TCySheetType;
    procedure SetCaption(const Value: TCaption);
    procedure SetHint(const Value: string);
    procedure SetSheetType(const Value: TCySheetType);
  public
    constructor Create(AOwner : TCyExcel);
    property Caption:TCaption read FCaption write SetCaption;
    property Hint:string read FHint write SetHint;
    property SheetType :TCySheetType read FSheetType write SetSheetType;
  end;

  { Notes:
    o  Property "Styler" have not be published
    }
  TCySheet = class( TCyCustomSheet)
  public

  published
    //inherited from TCyCustomSheet
    property Caption ;
    property Hint ;
    // inherited from TXLCustomSHeet
    property Title;
    property PrintLeftMargin ;
    property PrintTopMargin  ;
    property PrintRightMargin;
    property PrintBottomMargin;
    property PrintGridLines;
    property ColCount;
    property ColDefWidth;
    property ColMaxWidth;
    property RowCount;
    property RowDefHeight;
    property RowMaxHeight;
    property TitleCols;
    property TitleRows;
    property Background;
    property ReadOnly;
    property BaseClientStyle;
    property BaseTitleStyle ;

    property OnSizing ;
    property OnModified ;
    property OnCellClick ;
    property OnCellDblClick ;
    property OnStylerChanged ;

    property OnGetCellHint ;
    property OnCellChanged ;

  end;

  TCySheetItem = class(TCollectionItem)
  private
    FSheet : TCySheet ;
  public
    constructor Create(Collection: TCollection);    override ;
    destructor  Destroy ; override ;
  published
  end;

  TCySheets = class(TOwnedCollection)
  private
    FExcel :TCyExcel;
    function GetSheet(Index: Integer): TCySheet;
  protected
    function GetUniqueName: String;
  public
    constructor Create(AOwner: TCyExcel);
    procedure Added(var Item: TCollectionItem); override ;
    function AddSheet: TCySheet;
    function InsertSheet (AIndex:integer) :TCySheet ;
    function Find(const AName: string): TCySheet;
    property Items[Index: Integer]: TCySheet read GetSheet ; default;
  end;

  TCySheetNavBtnType = (ntFirst,ntPrior,ntNext ,ntLast);
  TCySheetNavButton = class(TSpeedButton)
  private
    FNavType: TCySheetNavBtnType;
    procedure SetNavType(const Value: TCySheetNavBtnType);
  published
    property NavType:TCySheetNavBtnType read FNavType write SetNavType;
  end;

  TCySheetNav = class(TCustomPanel)
  private
    FSheetTabSet:TCySheetTabSet;
    //Aggregate  Fout Speed Button
    FFirstSpdBtn:TCySheetNavButton;
    FPirorSpdBtn:TCySheetNavButton;
    FNextSpdBtn:TCySheetNavButton;
    FLastSpdBtn:TCySheetNavButton;
  protected
    Buttons: array[0..3] of TCySheetNavButton;
  public
    constructor Create(AOwner: TComponent ; ASheetTabSet :TCySheetTabSet);
    destructor  Destroy; override;
    //SpeedButton Click Event
    procedure   ButtonClick(Sender:TObject);
  published
    //...
  end;

  TCySheetPopupMenu = class(TPopupMenu)

  end;

  TCySheetTabList = class(TStringList)
  private
    FSheetTabSet: TCySheetTabSet;
  public
    procedure Insert(AIndex: Integer; const S: string); override;
    // Insert New TabSet Page  to CurIndex
    function Add(const S: string): Integer; override;
    // Insert New TabSet Page  to CurIndex And A Sheet Object Be  Created
    function New(var S: string) : Integer;
    // Only Delete TabSet Page
    procedure Delete(AIndex: Integer); override;
    // Delete TabSet Page And Free Refrence Sheet
    function Free(AIndex : integer ): Integer ; overload ;
    //Move TabSet Page and Sheet Position in Colliction 
    procedure Move(CurIndex, NewIndex: Integer); override ;
  end;

  TCySheetTabSet = class(TTabSet)
  private
    FSheetTabs :TCySheetTabList;
    FExcel:TCyExcel; //Assocate Excel for Control Sheet  (1..1)
    function CanChange(NewIndex: Integer): Boolean;
    function GetTabIndex: integer;
    procedure SetTabIndex(const Value: integer);
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(AOwner:TComponent ;AExcel:TCyExcel);
    destructor  Destroy ; override ;
    //FExcel.FSheets  ⲿģ޸˺ˢ
    procedure   Refresh;
    function  NewSheet(ACaption:String) :integer ;
    procedure DelSheet(AIndex :integer);
    procedure DelActiveSheet;
    procedure Rename(AIndex : integer ; lCaption : String );
    // Move Active Tab To Next
    procedure MoveDown;
    // Move Active Tab To Prior
    procedure MoveUp;

  published
    property TabIndex : integer Read GetTabIndex Write SetTabIndex ;
  end;

  TCyGrid = class(TXLCustomGrid)
  public
    property  Views ;
  published
    property  Scale              ;
    property  Options            ;
    property  Scrolls            ;
    property  OnColDblClick      ;
    property  OnRowDblClick      ;
    property  OnCellClick        ;
    property  OnCellDblClick     ;
    property  OnSelChanged       ;
    property  OnCurChanged       ;
    property  OnSheetChanged     ;
    property  OnEditModeChanged  ;
    property  OnScaleChanged     ;
    property  EnterDir           ;
  end;

  TCyGridScrollBar = class(TScrollBar)
  private
    FGrid :TCyGrid;
  protected
    procedure Scroll(ScrollCode: TScrollCode; var ScrollPos: Integer); override ;
  public
    constructor Create(AOwner :TComponent ; AGrid:TCyGrid) ;
  end;

  TCyStyler = class(TXLStyler)
  end;

  CyExcelException = Exception ;

  TCyExcel = class(TCustomPanel)
  private
    //Labout Panel
    FBottomPanel:TPanel;
    FSheetNavPanel:TPanel;
    FSheetTabSetPanel:TPanel;
    FSheetSbPanel:TPanel;

    FGrid:TCyGrid;           //XLGrid
    FSheets:TCySheets;       //Sheets
    FStyler:TCyStyler;
    FSheetNav:TCySheetNav;   //Sheet Navigator
    FSheetTabSet:TCySheetTabSet;    //Sheet TabSet
    FHScrollBar:TScrollBar;  //Scrollbar Wraper of Grid's Horizontal ScrollBar
    FVisibleOptions: TCyVisibleOptions;
    FColLabelStyle: TColLabelStyle;
    FDsgFileName: String;
    procedure SetVisibleOptions(const Value: TCyVisibleOptions);
    procedure SetColLabelStyle(const Value: TColLabelStyle);
//    function GetSheet(AIndex: integer): TCySheet;
    function GetSheets: TCySheets;
    procedure SetDsgFileName(const Value: String);
    function GetSheet(AIndex: integer): TCySheet;
  protected
    procedure DefineProperties(Filer: TFiler); override ;
    function  CreateSheet : TCySheet ;
    // if voColLable in [VisibleOptions] then this property is Valid (have not implementation !)
    property ColLabelStyle:TColLabelStyle read FColLabelStyle write SetColLabelStyle;
    procedure Load(AReader:TReader);
    procedure Stored(AWriter :TWriter);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DelSheet(AIndex : integer );
    //Refrence  Other cyExcel Component 's Sheets
    procedure RefrenceSheets(AExcel: TCyExcel);
    property  SheetTabSet:TCySheetTabSet read FSheetTabSet;    //Sheet TabSet
    //persistent interface
    procedure SaveToStream(AStream: TStream);
    procedure LoadFromStream(AStream: TStream );
    procedure LoadFromFile(AFileName:TFileName);
    procedure SaveTOFile(AFileName:TFileName);
    property  Sheets : TCySheets read GetSheets;
    // Open CyExcel Designer Window
    procedure Design;
  published
    //Set voColLabel and voRowLable will affect TitleRows and TitleCols Value
    property VisibleOptions:TCyVisibleOptions read FVisibleOptions write SetVisibleOptions;
    property Grid :TCyGrid read FGrid ;
    //趨DsgFileNameڱϢ浽ļ , Ҫڷʴ
    property DsgFileName : String  read FDsgFileName write SetDsgFileName;
    // TCustomPanel Property and Event
    property Align;
    property Alignment;
    property Anchors;
    property AutoSize;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BiDiMode;
    property BorderWidth;
    property BorderStyle;
    property Constraints;
    property Ctl3D;
    property UseDockManager default True;
    property DockSite;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FullRepaint;
    property Font;
    property Locked;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;

    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetSiteInfo;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

  TCyEditorSheets = class(TObject)
  private
    FCyExcel: TCyExcel;
    function GetSheets: TCySheets;
    procedure SetSheets(const Value: TCySheets);
  public
    property Sheets : TCySheets read GetSheets write SetSheets;
    constructor Create(AOwner : TObject ; ACyExcel:TCyExcel);
  end;
implementation

{$R CyExcel}
uses
  CyExcelDsg;

Const
  DEFAULT_WIDTH  = 500 ;
  DEFAULT_HEIGHT = 420 ;
  BOTTOM_HEIGHT  = 15  ;

{ TCyExcel }

//Refrence Other Excel 's Sheets
procedure TCyExcel.RefrenceSheets(AExcel: TCyExcel);
begin
  Self.FSheets := AExcel.FSheets;
  Self.FSheetTabSet.Refresh;
end;

constructor TCyExcel.Create(AOwner: TComponent);
var
  lSheet:TXLSheet;
begin
  inherited;
  //Component Default Style ;
  Self.BevelInner:=bvNone;
  Self.BevelOuter:=bvRaised;
  Self.Width := DEFAULT_WIDTH ;//500
  Self.Height := DEFAULT_HEIGHT ; //420 ;
  // Create Private Property
  FSheets := TCySheets.Create(Self);
  //Create Grid
  FGrid:=TCyGrid.Create(Self);
  FGrid.Name := 'CyGrid';
  FGrid.Parent := Self;
  FGrid.BevelInner:=bvLowered;
  FGrid.BevelOuter:=bvNone;
  FGrid.Align := alClient;
  FGrid.Scrolls := [ssVertical];//
  //Create Styler
  FStyler := TCyStyler.Create(self);

  //Create Layout Panel
  FBottomPanel :=TPanel.Create(Self);
  FBottomPanel.Parent := Self;
  FBottomPanel.BevelInner:=bvNone;
  FBottomPanel.BevelOuter:=bvNone;
  FBottomPanel.Align := alBottom;
  FBottomPanel.Height := BOTTOM_HEIGHT + 2 ;

  FSheetNavPanel:=TPanel.Create(Self);
  FSheetNavPanel.Parent := FBottomPanel;
  FSheetNavPanel.BevelInner:=bvLowered;
  FSheetNavPanel.BevelOuter:=bvNone;
  FSheetNavPanel.Align := alLeft;
  FSheetNavPanel.Width:= BOTTOM_HEIGHT * 4 + 2;

  FSheetSbPanel := TPanel.Create(self);
  FSheetSbPanel.Parent := FBottomPanel;
  FSheetSbPanel.BevelInner:=bvLowered;
  FSheetSbPanel.BevelOuter:=bvNone;
  FSheetSbPanel.Align := alRight;

  FHScrollBar:=TCyGridScrollBar.Create(self,FGrid);
  FHScrollBar.Parent:=FSheetSbPanel;
  FHScrollBar.Align := alClient;

  FSheetTabSetPanel := TPanel.Create(Self);
  FSheetTabSetPanel.Parent := FBottomPanel;
  FSheetTabSetPanel.BevelInner:=bvLowered;
  FSheetTabSetPanel.BevelOuter:=bvNone;
  FSheetTabSetPanel.Align := alClient;


  FSheetTabSet:=TCySheetTabSet.Create(FSheetTabSetPanel,Self);
  FSheetTabset.Parent := FSheetTabSetPanel;
  FSheetTabSet.Align := alClient;
  FSheetTabSet.SoftTop := true;
  FSheetTabSet.StartMargin :=0;
  FSheetTabSet.SelectedColor := clHighlightText ;
  FSheetTabSet.UnselectedColor := clBtnFace;

  //FSheetTabSet.NewSheet('Sheet1');
  FSheets.AddSheet;
  FSheetTabSet.Refresh ;
  
  FSheetNav:= TCySheetNav.Create(FSheetNavPanel,FSheetTabSet);
  FSheetNav.Parent := FSheetNavPanel;
  FSheetnav.Align := alClient;
  //Set Visible Options
  VisibleOptions := [voSheetNav,voSheetTabSet,voScrollBar ] // ,voRowLabel,voColLabel];
end;

procedure TCyExcel.LoadFromFile(AFileName: TFileName);
var
  lFileStream : TFileStream ;
begin
  try
    lFileStream := TFileStream.Create(AFilename,fmOpenRead);
    LoadFromStream(TXLStream(lFileStream));
  finally
    lFileStream.Free;
  end;

end;

procedure TCyExcel.SaveTOFile(AFileName: TFileName);
var
  lFileStream : TFileStream ;
begin
  lFileStream := TFileStream.Create(AFileName, fmCreate);
  try
    SaveToStream(TXLStream(lFileStream));
  finally
    lFileStream.Free;
  end;
end;

procedure TCyExcel.LoadFromStream(AStream: TStream);
var
  I  : Integer;
  lCount : Word;
  Signature: Array[0..3] of Char;
  OSF: Boolean;
  lCySheet:TCySheet;

begin
//  BeginUpdate;

  try
    FSheets.Clear;

    AStream.Read(Signature, 4);
    OSF := (Signature[0] <> 'C') or (Signature[1] <> 'Y') or (Signature[2] <> 'E');
    if OSF then AStream.Seek(-4, soFromCurrent);
    if OSF then InvalidOp('Unknown Cy Excel Stream format!');
    AStream.Read(lCount,SizeOf(Word));
    for I := 0 to lCount - 1 do    // Iterate
    begin
      if I < FSheets.Count   then
      begin
        FSheets.Items[I].LoadFromStream(TXLStream(AStream));
      end
      else begin
        lCySheet:= FSheets.AddSheet;
        lCySheet.LoadFromStream(TXLStream(AStream));
      end;
    end;    // for
    FSheetTabSet.Refresh;
  finally
//    EndUpdate;
//  SheetTabSet.Refresh ;
  end;
//  end;    // for

end;

procedure TCyExcel.SaveToStream(AStream: TStream);
var
  I :Integer ;
  lCount : Word;
  lSheet:TCySheet;
  lSignature: Array[0..3] of Char;
begin
  lCount := FSheets.Count ;

  lSignature := 'CYE' + Char($16);
  AStream.Write(lSignature, 4);
  AStream.Write(lCount , Sizeof(Word));
  for I := 0 to lCount - 1 do    // Iterate
  begin
    FSheets.Items[i].SaveToStream(TXLStream(AStream));
  end;    // for
end;

procedure TCyExcel.DefineProperties(Filer: TFiler);
begin
  inherited;
  if DsgFileName = '' then
  begin
    Filer.DefineBinaryProperty('SheetsData', LoadFromStream, SaveToStream, True);
  end
  else begin
    Filer.DefineProperty('InternalFileName', Load, Stored, True);
  end;
end;

procedure TCyExcel.DelSheet(AIndex: integer);
begin
  FSheetTabSet.Tabs.Delete(AIndex);
  FSheets.Delete(AIndex);
  FSheetTabSet.TabIndex := FSheetTabSet.TabIndex - 1 ;
end;

destructor TCyExcel.Destroy;
begin
  FSheets.Free;
  inherited;
end;

function TCyExcel.GetSheet(AIndex: integer): TCySheet;
begin
  result := FSheets.Items[AIndex];
end;

procedure TCyExcel.SetColLabelStyle(const Value: TColLabelStyle);
begin
  FColLabelStyle := Value;
end;

//õӱǷʾҳǩȣͬʱӰʽ
procedure TCyExcel.SetVisibleOptions(const Value: TCyVisibleOptions);
var
  I: Integer;
begin
  FVisibleOptions := Value;
  FSheetNavPanel.Visible := voSheetNav in Value;
  FSheetTabSetPanel.Visible := voSheetTabSet in Value;
  FSheetSbPanel.Visible :=   voScrollBar in Value ;
  if FSheetTabSetPanel.Visible  then
  begin
    FSheetSbPanel.Align := alRight;
  end
  else begin
    FSheetSbPanel.Align := alClient ;
  end;
  self.FBottomPanel.Visible :=   (FSheetNavPanel.Visible)
        or (  FSheetTabSetPanel.Visible)
        or (  FSheetSbPanel.Visible ) ;

end;

function TCyExcel.CreateSheet: TCySheet;
begin
  result :=   TCySheet.Create(self);
  result.Styler := FStyler;
end;

procedure TCyExcel.SetDsgFileName(const Value: String);
begin
  FDsgFileName := Value;
end;

function TCyExcel.GetSheets: TCySheets;
begin
  result := FSheets;
end;

{ TCySheetTabSet }

function TCySheetTabSet.CanChange(NewIndex: Integer): Boolean;
begin
  with FExcel do
  begin
    FGrid.Sheet :=TCySheet(FSheets[NewIndex]);
  end;
  inherited CanChange(NewIndex);
end;

constructor TCySheetTabSet.Create(AOwner: TComponent; AExcel : TCyExcel);
begin
  inherited Create(AOwner);
  FExcel:=AExcel;
  FSheetTabs:=TCySheetTabList.Create ;
  FSheetTabs.FSheetTabSet := Self ;
end;

procedure TCySheetTabSet.SetTabIndex(const Value: integer);
var
  SI:TScrollInfo;
begin
  if Value >= 0 then
  begin
    FExcel.FGrid.Sheet := FExcel.FSheets.Items[Value];
  end;
  inherited TabIndex := Value;
end;

function TCySheetTabSet.NewSheet(ACaption:String) : integer ;
begin
  result :=  FSheetTabs.New(ACaption);
end;

procedure TCySheetTabSet.DelSheet(AIndex : integer );
begin
  FSheetTabs.Delete(AIndex);
end;

procedure TCySheetTabSet.Rename(AIndex: integer; lCaption: String);
begin
  FExcel.Sheets[AIndex].Caption := lCaption ;
  FExcel.SheetTabSet.FSheetTabs.Strings [AIndex]:=lCaption;
  Fexcel.SheetTabSet.Tabs.Strings [AIndex] := lCaption ;
end;

procedure TCySheetTabSet.MoveDown;
begin
  if TabIndex < FSheetTabs.Count -1    then
  begin
    FSheetTabs.Move(TabIndex,TabIndex + 1 );
  end;

end;

procedure TCySheetTabSet.MoveUp;
begin
  if Tabindex > 0  then
  begin
    FSheetTabs.Move(TabIndex,TabIndex - 1 );
  end;
end;

procedure TCySheetTabSet.DelActiveSheet;
begin
  DelSheet(TabIndex);
end;

{ TCySheetNav }

var
  BtnTypeName: array[0..3] of PChar = ('FIRST', 'PRIOR', 'NEXT','LAST');
procedure TCySheetNav.ButtonClick(Sender: TObject);
var
  lTabIndex:Integer;
begin
  if Sender is TCySheetNavButton  then
  begin
    lTabIndex:=FSheetTabSet.TabIndex ;
    case (Sender as TCySheetNavButton).NavType  of
      ntFirst: FSheetTabSet.TabIndex := 0;
      ntPrior:
        if FSheetTabSet.TabIndex > 0 then
        begin
          FSheetTabSet.SelectNext(false);
        end;
      ntNext :
        if FSheetTabSet.TabIndex < FSheetTabSet.FSheetTabs.Count - 1  then
        begin
          FSheetTabSet.SelectNext(true);
        end;
      ntLast : FSheetTabSet.TabIndex := FSheetTabSet.Tabs.Count -1 ;
    end;    // case
  end;
    
end;

constructor TCySheetNav.Create(AOwner: TComponent; ASheetTabSet :TCySheetTabSet );
var
  i: Integer;
  lSpeedBtn:TCySheetNavButton;
  lResName : String;

begin
  inherited Create(AOwner);
  FSheetTabSet := ASheetTabSet;
  for I := 0 to 3 do    // Iterate
  begin
    lSpeedBtn:=TCySheetNavButton.Create(self);
    lSpeedBtn.Parent := self;
    FmtStr(lResName, 'SHN_%s', [BtnTypeName[I]]);
    lSpeedBtn.Glyph.LoadFromResourceName(HInstance, lResName);
    lSpeedBtn.NumGlyphs := 2;

    lSpeedBtn.Left := BOTTOM_HEIGHT *i+1;
    lSpeedBtn.Height := BOTTOM_HEIGHT;
    lSpeedBtn.Width := BOTTOM_HEIGHT ;
    lSpeedBtn.Top := 0;
    lSpeedBtn.Flat := True;
    lSpeedBtn.NavType:=TCySheetNavBtnType(I);
    lSpeedBtn.OnClick := ButtonClick;
    Buttons[i]:=lSpeedBtn;
  end;    // for
end;

destructor TCySheetNav.Destroy;
begin

  inherited;
end;

{ TSheetNavButton }

procedure TCySheetNavButton.SetNavType(const Value: TCySheetNavBtnType);
begin
  FNavType := Value;
end;

function TCySheetTabSet.GetTabIndex: integer;
begin
  result :=  inherited TabIndex;
end;

procedure TCySheetTabSet.MouseDown(Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
var
  lTabIndex:integer;
  lPos:TPoint;
begin
  lPos.X := X;
  lPos.Y := Y;
  lTabIndex := ItemAtPos(lPos);
  if ( lTabIndex <>  TabIndex ) and (lTabIndex >=0 )then
  begin
    SetTabIndex(lTabIndex);
  end;
  inherited;

end;

{ TCyCustomSheet }

constructor TCyCustomSheet.Create(AOwner: TCyExcel);
begin
  inherited Create(AOwner);

  self.ColDefWidth := 60 ;
  self.RowDefHeight := 20 ;

  self.ColCount := 30;
  self.RowCount := 200 ;
end;

procedure TCyCustomSheet.SetCaption(const Value: TCaption);
begin
  FCaption := Value;
  (Owner as TCyExcel).SheetTabSet.Refresh ;
end;

procedure TCyCustomSheet.SetHint(const Value: string);
begin
  FHint := Value;
end;

procedure TCyCustomSheet.SetSheetType(const Value: TCySheetType);
begin
  FSheetType := Value;
end;

{ TCySheetTabList }

function TCySheetTabList.Add(const S: string): Integer;
begin
  result :=  inherited Add(s);
  FSheetTabSet.TabIndex :=  FSheetTabSet.Tabs.Add(s);
end;

function TCySheetTabList.New(var S: string) : Integer ;
var
  lSheet : TCySheet;
  lIndex : Integer;
begin
  lIndex :=  FSheetTabSet.TabIndex ;//+ 1;
  if lIndex = -1  then
  begin
    lIndex := inherited Add(s);
    lSheet := FSheetTabSet.FExcel.Sheets.AddSheet ;
    if S = ''  then  S:= lSheet.Name ;
    FSheetTabSet.Tabs.Add(S);
  end
  else  begin
    inherited Insert(lIndex ,S);
    lSheet := FSheetTabSet.FExcel.Sheets.InsertSheet(lIndex);
    if S = ''  then  S:= lSheet.Name ;
    FSheetTabSet.Tabs.Insert(lIndex,S);
  end;
  lSheet.Caption := S;
  FSheetTabSet.FExcel.FGrid.Sheet := lSheet;
  FSheetTabSet.TabIndex := lIndex ;
  result :=lIndex;
end;

procedure TCySheetTabList.Delete(AIndex: Integer);
begin
  inherited Delete(AIndex);
  FSheetTabSet.FExcel.FSheets.Delete(AIndex);
  FSheetTabSet.Tabs.Delete(AIndex);
  if AIndex = FSheetTabSet.Tabs.Count   then // Last Sheet
  begin
    FSheetTabSet.TabIndex := AIndex - 1 ;
  end
  else begin
    FSheetTabSet.TabIndex := AIndex;
  end;
end;

function TCySheetTabList.Free(AIndex: integer): Integer;
begin
  if  Count = 1  then
  begin
    raise CyExcelException.Create(DELETE_ERROR);
  end;
  inherited Delete(AIndex);
  FSheetTabSet.FExcel.FSheets.Delete(AIndex);
  FSheetTabSet.Tabs.Delete(AIndex);
  FSheetTabSet.FExcel.FGrid.Sheet := FSheetTabSet.FExcel.Sheets [Self.FSheetTabSet.TabIndex];
end;

procedure TCySheetTabList.Insert(AIndex: Integer; const S: string);
var
  lSheet : TCySheet;
begin
  inherited Insert(AIndex , s );
  lSheet :=  FSheetTabSet.FExcel.FSheets.InsertSheet(AIndex) ;
  lSheet.Caption := S;
  FSheetTabSet.Tabs.Insert(AIndex,s);
end;

destructor TCySheetTabSet.Destroy;
begin
  FSheetTabs.Free;
  inherited;
end;

procedure TCySheetTabSet.Refresh;
var
  lIndex : Integer;
begin
  Tabs.Clear ;
  FSheetTabs.Clear;
  with FExcel.FSheets do
  begin
    for lIndex := 0 to Count - 1 do    // Iterate
    begin
      FSheetTabs.Add(FExcel.FSheets[lIndex].Caption );
    end;
  end;   // for
end;

procedure TCySheetTabList.Move(CurIndex, NewIndex: Integer);
var
  TempObject: TObject;
  TempString: string;
begin
  if CurIndex <> NewIndex then
  begin
    BeginUpdate;
    try
      TempString := Get(CurIndex);
      TempObject := GetObject(CurIndex);
      inherited Delete(CurIndex);
      InsertObject(NewIndex, TempString, TempObject);
    finally
      EndUpdate;
    end;
  end;
  FSheetTabSet.Tabs.Move(CurIndex,NewIndex);
  FSheetTabset.FExcel.FSheets.GetItem(CurIndex).Index := NewIndex;
end;

{ TCyGridScrollBar }

constructor TCyGridScrollBar.Create(AOwner: TComponent; AGrid: TCyGrid);
begin
  inherited Create(AOwner);
  FGrid := AGrid;
end;

procedure TCyGridScrollBar.Scroll(ScrollCode: TScrollCode;  var ScrollPos: Integer);
begin
  inherited;
  SendMessage(FGrid.Views.ClientView.Handle  , WM_HSCROLL , ScrollPos*256*256+Ord(ScrollCode),0);
end;

{ TCyEditorSheets }

constructor TCyEditorSheets.Create(AOwner: TObject; ACyExcel: TCyExcel);
begin
  FCyExcel := ACyExcel;
end;

function TCyEditorSheets.GetSheets: TCySheets;
begin
  result := FCyExcel.FSheets;
end;

procedure TCyEditorSheets.SetSheets(const Value: TCySheets);
begin
  FCyExcel.FSheets := Value ;
end;

procedure TCyExcel.Load(AReader: TReader);
begin
  DsgFileName:=  AReader.ReadString ;
  LoadFromFile(DsgFileName);
end;

procedure TCyExcel.Stored(AWriter: TWriter);
begin
  AWriter.WriteString(DsgFileName);
  Self.SaveTOFile(DsgFileName);
end;

procedure TCyExcel.Design;
begin
  OpenCyExcelDesigner(Self);
end;

{ TCySheets }

procedure TCySheets.Added(var Item: TCollectionItem);
begin
  inherited;

end;

function TCySheets.AddSheet: TCySheet;
var
  lSheetItem : TCySheetItem ;
begin
  lSheetItem := TCySheetItem(inherited Add);
  result := lSheetItem.FSheet;
end;

constructor TCySheets.Create(AOwner: TCyExcel);
begin
  inherited Create(AOwner, TCySheetItem);
  FExcel:=AOwner;
end;

function TCySheets.Find(const AName: string): TCySheet;
var
  I : integer;
begin

  result := nil ;
  for I := 0 to Count - 1 do    // Iterate
  begin
    if Items[I].Name = AName  then
    begin
      result := Items[I];
    end;
  end;    // for

end;


function TCySheets.GetSheet(Index: Integer): TCySheet;
begin
  result := TCySheetItem(inherited Items[Index]).FSheet ;
end;

function TCySheets.GetUniqueName: String;
var
  lIndex , i :integer;
begin
  lIndex := Count   ;
  repeat
    result := SHEET_CAPTION + IntToStr(lIndex);
    lIndex := lIndex + 1 ;
  until Find(result) = nil ;
end;

function TCySheets.InsertSheet(AIndex: integer): TCySheet;
begin
  result :=  TCySheetItem(inherited Insert(AIndex)).FSheet ;
end;

{ TCySheetItem }

constructor TCySheetItem.Create(Collection: TCollection);
begin
  inherited;
  if Collection is TCySheets then
  begin
    FSheet := TCySheet.Create((Collection as TCySheets).FExcel );
    FSheet.Name := (Collection as TCySheets).GetUniqueName;
    FSheet.Caption := FSheet.Name ;
    FSheet.Styler :=(Collection as TCySheets).FExcel.FStyler ;
  end;
end;


destructor TCySheetItem.Destroy;
begin
  FSheet.Free;
  inherited;
end;


end.
