
unit CyExcelReg;

interface
uses Classes,SysUtils,
     //DsgnIntf,
     DesignIntf, DesignEditors,VCLEditors,Consts, Windows, Forms ,
     CyExcel , CyExcelDsg ,CySheetsDsg ;

type
  TCyExcelEditor = class(TComponentEditor)
  private
    FCyExcelEditorSheets : TCyEditorSheets;
    FSheets :TCySheets;
  public
    procedure Edit; override;
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  procedure Register;

implementation


procedure Register;
begin
  { Component Registration But No Show  on Components Panel}
  RegisterNoIcon([TCySheet]);
  { Component Registration }
  RegisterComponents('CyControls',[TCyExcel]);
  { Component Editor Registration }
  RegisterComponentEditor(TCyExcel, TCyExcelEditor);
  { Property Category registration }
  RegisterPropertyInCategory('Visual',TCyExcel,'VisibleOptions');
  { Property Editor Registration }
//  RegisterPropertyEditor(TypeInfo(TCySheets), TCyExcel, 'Sheets', TCySheetsEditor);
end;

{ TXLSheetEditor }
//==================================================================================================

procedure TCyExcelEditor.Edit;
begin
  OpenCyExcelDesigner(TCyExcel(Component));
end;


procedure TCyExcelEditor.ExecuteVerb(Index: Integer);
begin
  if Index = 0 then
  begin
    ShowSheetsEditor(Designer,TCyExcel(Component));
  end;
end;

function TCyExcelEditor.GetVerb(Index: Integer): string;
begin
  result :='Sheets Editor';
end;

function TCyExcelEditor.GetVerbCount: Integer;
begin
  result := 1 ;
end;


end.
