{-----------------------------------------------------------------------------
 Unit Name: MSOAddIn_Defs

 Author:    Vadim Krochak
 Copyright:  2003 All rights reserved.
 E.Mail:    vkrochak@bezeqnt.net
 License:   Don't redistribute for cash.  Don't change and
  redistribute under your name.  Let me know if you fix anything or improve
  anything.

 Purpose: MSOAddIn definitions
 History:
-----------------------------------------------------------------------------}

{ Delphi 6 }
{$IFDEF VER140}
  {$DEFINE DELPHI5_UP}
{$ENDIF}

{ Delphi 7 }
{$IFDEF VER150}
  {$DEFINE DELPHI5_UP}
{$ENDIF}

unit MSOAddIn_Defs;

interface

{$IFDEF DELPHI5_UP}

{{*** VK ************************************
  In Delphi 6-7 'EmptyParam' var was
  removed from System unit and moved to
  'Variants' unit. Following is 'replacement'
  of this global var for Delphi 6-7 (Of course,
  you can include 'Varians' unit, but this trick
  on project wide level more usefull for
  Delphi 5-6-7 compilation IMHO).
********************************************}
var
  EmptyParam: OleVariant;

{$ENDIF}

const

  //VK: Common:
	ADDIN_KEY = {HKCU\}'Software\Microsoft\Office\%s\Addins\%s';
  TAG_SUFFIX = '$$$';

  //VK: Outlook addin stuff:
 	OUTLOOKADDIN_CMD_BAR_NAME = 'MS Outlook 2000/XP Sample Addin Bar';
  OUTLOOKADDIN_BTN_NAME = 'New Contact';
  OUTLOOK_MAPI = 'MAPI';
  OUTLOOK_APP  = 'Outlook';
  OUTLOOKADDIN_NAME = 'MS Outlook 2000/XP Sample Addin';
  OUTLOOKADDIN_DESCRIPTION = 'MS Outlook 2000/XP Sample Addin in Delphi';

  //VK: Word addin stuff:
 	WORDADDIN_CMD_BAR_NAME = 'MS Word 2000/XP Sample Addin Bar';
  WORDADDIN_BTN_NAME = 'New Contact Info';
  WORD_APP  = 'Word';
  WORDADDIN_NAME = 'MS Word 2000/XP Sample Addin';
  WORDADDIN_DESCRIPTION = 'MS Word 2000/XP Sample Addin in Delphi';

  //VK: Excel addin stuff:
 	EXCELADDIN_CMD_BAR_NAME = 'MS Excel 2000/XP Sample Addin Bar';
  EXCELADDIN_BTN_NAME = 'New Contact Info';
  EXCEL_APP  = 'Excel';
  EXCELADDIN_NAME = 'MS Excel 2000/XP Sample Addin';
  EXCELADDIN_DESCRIPTION = 'MS Excel 2000/XP Sample Addin in Delphi';

implementation

{$IFDEF DELPHI5_UP}

initialization
  TVarData(EmptyParam).VType := varError;
  TVarData(EmptyParam).VError := $80020004; {DISP_E_PARAMNOTFOUND}

{$ENDIF}

end.
