unit frm_;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shProgs, THostChecker_, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    RadioGroup1: TRadioGroup;
    HostChecker1: THostChecker;
    procedure HostChecker1Log(Sender: TObject; LogID: String; var Msg: String; var LogLevel: Byte; var LogStatus: TLogStatus);
    procedure Button1Click(Sender: TObject);
    procedure HostChecker1Link(Sender: TObject);
    procedure HostChecker1NoLink(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.HostChecker1Log(Sender: TObject; LogID: String; var Msg: String; var LogLevel: Byte; var LogStatus: TLogStatus);
begin
//if LogLevel=llList then
 Memo1.Lines.Add(LogID+' -:- '+ Msg);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if length(trim(Edit1.Text))=0 then exit; // not a must, just a check if edit box is empty
  HostChecker1.HostName:=Edit1.Text;
  HostChecker1.Execute
end;

procedure TForm1.HostChecker1Link(Sender: TObject);
begin
   MessageDlg('Link to '+ HostChecker1.HostName + ' exists.',mtInformation,[mbOk],0);
end;

procedure TForm1.HostChecker1NoLink(Sender: TObject);
begin
   MessageDlg('No link to '+ HostChecker1.HostName + ' !',mtWarning,[mbOk],0);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 if RadioGroup1.ItemIndex=0
  then HostChecker1.PingMode:=hpmSimultaneous
 else if RadioGroup1.ItemIndex=1
  then HostChecker1.PingMode:=hpmOneByOne;

end;

end.
