{
     2000-2003  Sovren Group, Inc.  May be used if this header
                 is retained and any code ,ods are noted.

    OWNER:              Sovren Group, Inc.     www.sovren.com
    AUTHOR:             Robert H. Ruff         info@sovren.com
    DELPHI VERSION:     5.  Should be backward compatible to all 32-bit.
    CUSTOM UNITS USED:
    DESCRIPTION:
    MODIFIED:



    NOTE:    This code can easily be transferred to any GUI control such as
             TMaskEdit, TdbEdit, etc.
}
unit prEdit;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls;

type
  TprEdit = class(TEdit)
  private
    FOrigColor : TColor;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    procedure DoEnter; override;
    procedure DoExit; override;
  end;

procedure Register;

implementation

const
    FHasFocusColor = clYellow;

procedure Register;
begin
  RegisterComponents('Standard', [TprEdit]);
end;

{ TprEdit }

procedure TprEdit.DoEnter;
begin
  inherited;
  if (FOrigColor <= 0) then
    FOrigColor := Color;
  if not ReadOnly then
    Color := FHasFocusColor;
end;

procedure TprEdit.DoExit;
begin
  inherited;
  if Color = FHasFocusColor then
    Color := FOrigColor;
end;

end.

