(*
Version: 1.21m


Version History
-------------------------------------------------------------------------------
1.21m: loop    25.01.2003
add:    function idxInArr(num:integer;arr:array of integer):integer;
        descr: result is the possition of a num in array of integer (arr) -
         if num was not found in the array then result is -1;
add:    function numCntInArray(num:integer;arr:array of integer):integer;
        descr: result is the count of num in array of integer (arr);
add:    function findNotInArr(arr:array of integer;Min,Max,IfFailed :integer):integer;
        descr: tryes to find an integer, wich is in bounds of Min and Max and is not found in
                the array of integer arr. If search fails, returns IfFailed.
                  usefull if you must find a free number in example -
                   for a document or record - just put all known numbers in arr and u r ready.
add:    procedure FailMsg(Id,Msg:string);
        descr: Shows a simple MessageDialog of type mtError - message is formated : Id+': '+ trim(Msg),
                usefull & time saving I think;
-------------------------------------------------------------------------------
1.21l: NoGarD    13.01.2003
fix:   procedure CheckUpdateEXE(MillisecondsToWait:Cardinal; HaltIfFailed:boolean);
          Descr: A little but critical mistake.
add:   function ExecLink(Link:string):boolean;
          Descr: Opens Link in new Internet Browser window or opens it in Mail Client. Returns if it was seccessful.
add:   var OnExecLinkErrorShowMessage:string='';
          Descr: If it is not '' and there is an error in ExecLink (appears when not internet client is found)
                  an error message will be shown with this error message.
-------------------------------------------------------------------------------
1.21k: NoGarD    10.01.2003
fix:   function function GetInetFile(const fileURL, AppName, FileName: String;
                  Terminated:pboolean; OnProgress:TNotifyEvent;
                    OnProgressSize:TNotifyInteger = nil): boolean;
          Descr: Added OnProgressSize:TNotifyInteger. When assigned returns the bytes downloaded till now.
                 Added Terminated:Pboolean - pointer to a boolean variable, when you need to terminate the
                   download you must set this variable to true.
add:   Type TNotifyInteger = procedure(Sender: TObject;Int:integer) of object;
          Descr: Used by GetInetFile and can be used when needed a NotifyEvent with integer property.
fix:   function MakeRotatingSplash(CurrentState:string):string;
          Descr: Optimized.
-------------------------------------------------------------------------------
1.21j: loop    09.01.2003
add:   function SaveLoadFromReg(const RegKey,Name :string; Action:TRegistryAction;
                                ValueType:TRegistryValueType;CanCreate:boolean;
                                                         var Value:Variant):boolean;
          Descr: You can use it to save, load from a registry key (RegKey ) ot just check iv a value named (Name )exists (when Acton=raCheck);
           The result of the function allways shows if a value by that name (name) was found before the function was executed.
           If you set the CanCreate to true and the action is raWrite that reg key will be created and the Value will be set even if it was a
                not existing befor execute;
add:   Type TRegistryAction
          Descr: raCheck,raWrite,raRead - the names talk themself;
add:   Type TRegistryValueType
          Descr: You supply a variant parametter to function but it must know what kind of value you
                 are expectiong from it to read or write for you;
-------------------------------------------------------------------------------
1.21i: NoGarD   09.01.2003
add:   function ReplaceStr(const SubstrToRaplce,RaplaceStr,Str:string):string;
          Descr: Replaces all appearances of SubstrToRaplce in Str with RaplaceStr.
          Ex:    ReplaceStr('!!','!','hehe!!! haha!!!!!')  --> 'hehe!! haha!!!'.
-------------------------------------------------------------------------------
1.21h: NoGarD   09.01.2003
add:   function GetParamValue(OptionName:string; HasHaveValue:boolean = false;
             ValueSeparator:char = ' '; TRUEStirng:string = '1'; FALSEString:string = '0';
                     ErrorString:string = 'error'; UseThisParamHeader:string = 'Use Global ParamHeaders'):string;
          Descr: Retrievs value of an Option from parameters passed to program.
                 If HasHaveValue is TRUE then wanted parameter must have value and if it have result is the value,
                  if it does not exist or does not have value, result is ErrorString.
                 ValueSeparator is char that separates name from value, defult is ' '(name value).
                 If HasHaveValue is FLASE then if exists result is TRUEStirng else result is FALSEString;
                 UseThisParamHeader is overwriter for ParamHeaders.
          Ex:    if GetParamValue('startexplorer')='1' then ....{exists}
                 filename:=GetParamValue('filename',true,'=','-1','-1','-1','/'); if filename<>'-1' then ....(exist,have value,with '/' header)
add:   procedure SetParamHeaders(UseParamHeadersA:boolean;ParamHeadersA:string = 'Don''t Change'; HeaderDelimiter:char = ';');
          Descr: Sets ParamHeaders...:). UseParamHeadersA: To use or not to use them. ParamHeadersA: String that
                  contains 1 or more headers witch is separated from HeaderDelimiter;
add:   var ParamHeaders:array of string;
          Descr: Headers that will be used from GetParmValue. The Default are: ('/','-').
          Note:  If you want to use for example '-' and '--' you must place '--' before '-'.
add:   var UseParamHeaders:boolean;
          Descr: If TRUE than GetParamValue will watch for every one of the ParamHeaders placed exactly before
                  OptinName, and if ther is no such hits will return FALSEString.
add:   procedure UpdateEXE(NewExe:string; CurExeNewName:string; DeleteCurExe:boolean = true; DontHalt:boolean = false);
          Descr: Updates current executable with other one (NewExe). CurExeNewName: temporary place
                  and name for the current executable. DeleteCurExe: to delete or not old (current)
                  executable when all the rest from updating is finished. DontHalt: if TRUE halts
                  the program before return (only if there was no errors).
          Ex:    UpdateEXE('NewExe', 'oldexe', true, false);
          Note:  It MUST be used with CheckUpdateEXE!
add:   procedure CheckUpdateEXE(MillisecondsToWait:Cardinal = 3000; HaltIfFailed:boolean = true);
          Descr: Do the most of work of UpdateEXE. Must be placed in the project unit before all other calls
                  to other procedures or functions!
                 It is not necessarily the new executable to have this procedure to Update be comlete but
                  if not DeleteCurExe will not work. MillisecondsToWait: how much time procedure will wait
                  the original copy of program to be fully closed. HaltIfFailed: If some error occurs
                  to halt the program or not (if it is deleting the old executable it will not halt anyway).
          EX:    CheckUpdateEXE(5000,true);
add:   var UpdateEXEError:integer;
          Descr: If some error occurs in UpdateEXE or CheckUpdateEXE its code will be writen here.
add:   function UpdateEXEErrorMessage(ShowMessageDialog:boolean = false):string;
          Descr: Returns UpdateEXEError code in text message. if ShowMessageDialog is TRUE it will show message dialog.
-------------------------------------------------------------------------------
1.21g: loop   07.01.2003
fix:   Unit name change from Progs to shProgs
-------------------------------------------------------------------------------
1.21f: loop   06.01.2003
add:   function MakeProgressString(PrChar:Char; CurrentState:string; MaxCount:word):string;
          Descr: Use it in any TNotifyEvent and assign result to some caption to indicate activity.
                  if combyned with CountStr you can do a progress bar move too.

add:   function MakeRotatingSplash(CurrentState:string):string;
          Descr: Use it in any TNotifyEvent and assign result to some caption to indicate activity.

add:   function GetInetFile(const fileURL, AppName, FileName: String; OnProgress:TNotifyEvent): boolean;
          Descr: Downloads a file from url. Not threaded and that suxx, but usefull for small files and fast links.
          ex:
          if GetInetFile(http://www.mp3-bg.com/dl/15731/462530/(--www.MP3-BG.com--)Joro%20Vachev%20-%20Sam%20Do%20Teb.mp3
                                ,Application.Name,
                                        'C:\test.mp3',nil)=True then
                  ShowMessage('Download successful')
         else
                  ShowMessage('Error in file download');

add:   procedure returnweeks(const pFrom,pTo: TDateTime ;var ResArr:array of string;  Fmt:string  = '%d_%d');
          Descr:Returns weeks numbers between pFrom & pTo. Fills RessArr with strings, formated by Fmt -
                - when default format is used each ellement of the array represents weeknum_year.
                         ex : 53_2003, 54_2003 etc.
-------------------------------------------------------------------------------
1.21e: NoGarD   03.01.2003

fix:    function checkIP(const IP: string): boolean; (optimized)

add:    function IntInBounds(const Value:integer;Min,Max:integer):boolean;
           Descr: Returns Min<=Value<=Max

add:    function CountStr(Substr:string;S:string):integer;
           Descr: Returns count of SubStr in S

-------------------------------------------------------------------------------
1.21d: loop     03.01.2003

fix:    function ReturnMaxDay; (year-end problem fixed)

add:    function returnBegOfDay(const Dt:TDateTime):TDateTime;
           Descr:Returns the beginning of the day on Dt
                 ex: dt=12.02.2002 13:47:55 - result=12.02.2002 00:00:00

add:    Type TPeriodLengthKind=(plDay,plMonth,plYear, plHour, plMinute);
           Descr:Used by ReturnPeriodBound to specify what Value means (the units of value )

add:    function ReturnPeriodBound(const PeriodStartBound:TDateTime;
                             const PKind:TPeriodLengthKind;
                                const Value:byte; const Direction:boolean):TDateTime;
           Descr:Returns result of type TDateTime, with "Value" units
                 greater or lower (depends on direction (+ when true, - when false))
                   from PeriodStartBound. Units depend on value of PKind.

-------------------------------------------------------------------------------
1.21c: NoGarD
add:    function ExtractFileNameAbs(const FileName: string):string;
           Descr: Returns FileName without path and extension
           Exam:  ExtractFileNameAbs('C:\abc\test22.txt')  >>  'test22'

-------------------------------------------------------------------------------
1.21b: NoGarD
fix:    function MysqlDateToStr(Dt,Fmt: string): string;
add:    function MysqlTimeStampToStr(Dt,Fmt: string): string;

-------------------------------------------------------------------------------
1.21a: NoGarD
add:    function posn(Substr:string;S:string;Index:integer):integer;
add:    function copye(S:string;Index:integer;IndexEnd:integer=32000):string;

-------------------------------------------------------------------------------
1.21:  loop
add:   all before 1.21a
-------------------------------------------------------------------------------
*)
unit shProgs;
interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Dialogs,
  ExtCtrls, comctrls, DateUtils,Wininet,shellapi, registry;


const


 // loglevel
 //  unused,logfile,loglist,message,quit,prstart,prevent,prend;

  llFile: byte = 64; //x100000 logfile
  llList: byte = 96; //x110000 logfile + loglist
  llMess: byte = 80; //x1010000 logfile + message
  llListMess: byte = 112; //x1110000 logfile + loglist+message
  llFatErrQuit: byte = 104; //x1101000 logfile + loglist+fatal error msg + quit app

  llProgrStart: byte = 68; //x1000100 startprogres
  llListProgrStart: byte = 100; //x1100100 startprogres + loglist
  llProgrEvent: byte = 2; //x0000010
  llListProgrEvent: byte = 98; //x1100010
  llListProgrEnd: byte = 97; //x1100001
  llListProgrEndMess: byte = 113; //x1110001

 ToUpperChars: array[0..255] of Char =
    (#$00,#$01,#$02,#$03,#$04,#$05,#$06,#$07,#$08,#$09,#$0A,#$0B,#$0C,#$0D,#$0E,#$0F,
     #$10,#$11,#$12,#$13,#$14,#$15,#$16,#$17,#$18,#$19,#$1A,#$1B,#$1C,#$1D,#$1E,#$1F,
     #$20,#$21,#$22,#$23,#$24,#$25,#$26,#$27,#$28,#$29,#$2A,#$2B,#$2C,#$2D,#$2E,#$2F,
     #$30,#$31,#$32,#$33,#$34,#$35,#$36,#$37,#$38,#$39,#$3A,#$3B,#$3C,#$3D,#$3E,#$3F,
     #$40,#$41,#$42,#$43,#$44,#$45,#$46,#$47,#$48,#$49,#$4A,#$4B,#$4C,#$4D,#$4E,#$4F,
     #$50,#$51,#$52,#$53,#$54,#$55,#$56,#$57,#$58,#$59,#$5A,#$5B,#$5C,#$5D,#$5E,#$5F,
     #$60,#$41,#$42,#$43,#$44,#$45,#$46,#$47,#$48,#$49,#$4A,#$4B,#$4C,#$4D,#$4E,#$4F,
     #$50,#$51,#$52,#$53,#$54,#$55,#$56,#$57,#$58,#$59,#$5A,#$7B,#$7C,#$7D,#$7E,#$7F,
     #$80,#$81,#$82,#$81,#$84,#$85,#$86,#$87,#$88,#$89,#$8A,#$8B,#$8C,#$8D,#$8E,#$8F,
     #$80,#$91,#$92,#$93,#$94,#$95,#$96,#$97,#$98,#$99,#$8A,#$9B,#$8C,#$8D,#$8E,#$8F,
     #$A0,#$A1,#$A1,#$A3,#$A4,#$A5,#$A6,#$A7,#$A8,#$A9,#$AA,#$AB,#$AC,#$AD,#$AE,#$AF,
     #$B0,#$B1,#$B2,#$B2,#$A5,#$B5,#$B6,#$B7,#$A8,#$B9,#$AA,#$BB,#$A3,#$BD,#$BD,#$AF,
     #$C0,#$C1,#$C2,#$C3,#$C4,#$C5,#$C6,#$C7,#$C8,#$C9,#$CA,#$CB,#$CC,#$CD,#$CE,#$CF,
     #$D0,#$D1,#$D2,#$D3,#$D4,#$D5,#$D6,#$D7,#$D8,#$D9,#$DA,#$DB,#$DC,#$DD,#$DE,#$DF,
     #$C0,#$C1,#$C2,#$C3,#$C4,#$C5,#$C6,#$C7,#$C8,#$C9,#$CA,#$CB,#$CC,#$CD,#$CE,#$CF,
     #$D0,#$D1,#$D2,#$D3,#$D4,#$D5,#$D6,#$D7,#$D8,#$D9,#$DA,#$DB,#$DC,#$DD,#$DE,#$DF);

  ToLowerChars: array[0..255] of Char =
    (#$00,#$01,#$02,#$03,#$04,#$05,#$06,#$07,#$08,#$09,#$0A,#$0B,#$0C,#$0D,#$0E,#$0F,
     #$10,#$11,#$12,#$13,#$14,#$15,#$16,#$17,#$18,#$19,#$1A,#$1B,#$1C,#$1D,#$1E,#$1F,
     #$20,#$21,#$22,#$23,#$24,#$25,#$26,#$27,#$28,#$29,#$2A,#$2B,#$2C,#$2D,#$2E,#$2F,
     #$30,#$31,#$32,#$33,#$34,#$35,#$36,#$37,#$38,#$39,#$3A,#$3B,#$3C,#$3D,#$3E,#$3F,
     #$40,#$61,#$62,#$63,#$64,#$65,#$66,#$67,#$68,#$69,#$6A,#$6B,#$6C,#$6D,#$6E,#$6F,
     #$70,#$71,#$72,#$73,#$74,#$75,#$76,#$77,#$78,#$79,#$7A,#$5B,#$5C,#$5D,#$5E,#$5F,
     #$60,#$61,#$62,#$63,#$64,#$65,#$66,#$67,#$68,#$69,#$6A,#$6B,#$6C,#$6D,#$6E,#$6F,
     #$70,#$71,#$72,#$73,#$74,#$75,#$76,#$77,#$78,#$79,#$7A,#$7B,#$7C,#$7D,#$7E,#$7F,
     #$90,#$83,#$82,#$83,#$84,#$85,#$86,#$87,#$88,#$89,#$9A,#$8B,#$9C,#$9D,#$9E,#$9F,
     #$90,#$91,#$92,#$93,#$94,#$95,#$96,#$97,#$98,#$99,#$9A,#$9B,#$9C,#$9D,#$9E,#$9F,
     #$A0,#$A2,#$A2,#$BC,#$A4,#$B4,#$A6,#$A7,#$B8,#$A9,#$BA,#$AB,#$AC,#$AD,#$AE,#$BF,
     #$B0,#$B1,#$B3,#$B3,#$B4,#$B5,#$B6,#$B7,#$B8,#$B9,#$BA,#$BB,#$BC,#$BE,#$BE,#$BF,
     #$E0,#$E1,#$E2,#$E3,#$E4,#$E5,#$E6,#$E7,#$E8,#$E9,#$EA,#$EB,#$EC,#$ED,#$EE,#$EF,
     #$F0,#$F1,#$F2,#$F3,#$F4,#$F5,#$F6,#$F7,#$F8,#$F9,#$FA,#$FB,#$FC,#$FD,#$FE,#$FF,
     #$E0,#$E1,#$E2,#$E3,#$E4,#$E5,#$E6,#$E7,#$E8,#$E9,#$EA,#$EB,#$EC,#$ED,#$EE,#$EF,
     #$F0,#$F1,#$F2,#$F3,#$F4,#$F5,#$F6,#$F7,#$F8,#$F9,#$FA,#$FB,#$FC,#$FD,#$FE,#$FF);

 type
   TLogStatus = (stStart, stStop, stWorking, stFailed, stSuccess, stError, stQuit, stExit, stDontCare, stReady);
   TOnLog = procedure (Sender:TObject;LogID:String; var Msg:String;var LogLevel:Byte; var LogStatus:TLogStatus ) of object;

   TPeriodLengthKind=(plSec,plMin,plHour,plDay,plMonth,plYear);
   TRegistryAction= (raWrite,raRead,raCheck);
   TRegistryValueType = (rvtBinaryData,rvtBool,rvtCurrency,
                                rvtDate,rvtDateTime,rvtFloat,
                                rvtInteger,rvtString,rvtTime);

   TWeekArr=array of string;


   TCellCoord=record
    row:integer;
    col:integer;
   end;
TNotifyInteger = procedure(Sender: TObject;Int:integer) of object;


{misk}

procedure FailMsg(Id,Msg:string);
function checkIP(const IP: string): boolean;

function SaveLoadFromReg(const RegKey,Name :string; Action:TRegistryAction;
                                ValueType:TRegistryValueType;CanCreate:boolean;
                                                         var Value:Variant):boolean;
function ExecLink(Link:string):boolean;

{num related}
function IntInBounds(const Value:integer;Min,Max:integer):boolean;
function NumInArr(num:integer;arr:array of integer):boolean;
function idxInArr(num:integer;arr:array of integer):integer;
function numCntInArray(num:integer;arr:array of integer):integer;
function findNotInArr(arr:array of integer;Min,Max,IfFailed:integer):integer;

{files related}

function GetInetFile(const fileURL, AppName, FileName: String; Terminated:pboolean; OnProgress:TNotifyEvent; OnProgressSize:TNotifyInteger): boolean;
function ExtractFileNameAbs(const FileName: string):string;
function GetParamValue(OptionName:string; HasHaveValue:boolean = false;
             ValueSeparator:char = ' '; TRUEStirng:string = '1'; FALSEString:string = '0';
                     ErrorString:string = 'error'; UseThisParamHeader:string = 'Use Global ParamHeaders'):string;
procedure SetParamHeaders(UseParamHeadersA:boolean;ParamHeadersA:string = 'Don''t Change'; HeaderDelimiter:char = ';');
procedure UpdateEXE(NewExe:string; CurExeNewName:string; DeleteCurExe:boolean = true; DontHalt:boolean = false);
procedure CheckUpdateEXE(MillisecondsToWait:Cardinal = 3000; HaltIfFailed:boolean = true);
function UpdateEXEErrorMessage(ShowMessageDialog:boolean = false):string;

{date-time related}

function returnDay(D: TDateTime): word;
function returnmonth(D: TDateTime): word;
function returnYear(D: TDateTime): word;
function returnHour(D: TDateTime): word;
function returnMins(D: TDateTime): word;


procedure returnweeks(const pFrom,pTo: TDateTime ;var ResArr:TWeekArr;  Fmt:string  = '%d_%d');
function ReturnPeriodBound(const PeriodStartBound:TDateTime;
        const PKind:TPeriodLengthKind;
                const Value:word; const Direction:boolean):TDateTime;
function returnBegOfDay(const Dt:TDateTime):TDateTime;
function returnEndOfDay(const Dt:TDateTime):TDateTime;
function returnMaxDay(D: TDateTime): word;
function SecToHMS(S: Cardinal): string;
function MysqlDateToStr(Dt,Fmt: string): string;
function MysqlTimeStampToStr(Dt,Fmt: string): string;
function DateToMysql(Dt:TDAteTime):string;
function StartOfMonth(Dt: TDateTime): TDateTime;
function StartOfYear(Dt: TDateTime): TDateTime;
function EndOfMonth(Dt: TDateTime): TDateTime;

{string related}
function MakeProgressString(PrChar:Char; CurrentState:string; MaxCount:word):string;
function MakeRotatingSplash(CurrentState:string):string;
function StrScan(const S: string; Ch: Char; StartPos: Integer = 1): Integer;
function TestByMask(const S, Mask: string; MaskChar: Char = 'X'): Boolean;
function TestWildStr(const S, Mask: string; MaskChar: Char = '?'; WildCard: Char = '*'): Boolean;
function TestWildText(const S, Mask: string; MaskChar: Char = '?'; WildCard: Char = '*'): Boolean;
function PosN(Substr:string;S:string;Index:integer):integer;
function CountStr(Substr:string;S:string):integer;
function CopyE(S:string;Index:integer;IndexEnd:integer=32000):string;
function ReplaceStr(const SubstrToRaplce,RaplaceStr,Str:string):string;

var ParamHeaders:array of string;
    UseParamHeaders:boolean;
    UpdateEXEError:integer=0;
    OnExecLinkErrorShowMessage:string='';  //'There is no Internet Browser installed!';

implementation

function ExtractFileNameAbs(const FileName: string):string;
begin
  result:=copy(ExtractFileName(FileName),1,length(ExtractFileName(FileName))-length(ExtractFileExt(ExtractFileName(FileName))));
end;

function copye(S:string;Index:integer;IndexEnd:integer):string;
begin
  result:=copy(S,Index,IndexEnd-Index+1);
end;

function posn(Substr:string;S:string;Index:integer):integer;
var i,al:integer;
begin
  if Index=0 then begin result:=0; exit; end;
  i:=0;
  al:=length(s);
  while pos(Substr,s)>0 do
   begin
     inc(i);
     if i=Index then begin result:=al-length(s)+pos(Substr,s); exit; end;
     s:=copye(s,pos(Substr,s)+length(Substr));
   end;
  result:=-1;
end;

function CountStr(Substr:string;S:string):integer;
begin
  result:=0;
  while pos(Substr,s)>0 do
   begin
     inc(result);
     s:=copye(s,pos(Substr,s)+length(Substr));
   end;
end;

function IntInBounds(const Value:integer;Min,Max:integer):boolean;
begin
  result:=(Value>=Min) and (Value<=Max);
end;

function checkIP(const IP: string): boolean;
begin
  result:=false;
  if CountStr('.',IP)<>3 then exit;
  if not(IntInBounds(StrToIntDef(copye(IP,1,posn('.',IP,1)-1),-1),0,255)) then exit;
  if not(IntInBounds(StrToIntDef(copye(IP,posn('.',IP,1)+1,posn('.',IP,2)-1),-1),0,255)) then exit;
  if not(IntInBounds(StrToIntDef(copye(IP,posn('.',IP,2)+1,posn('.',IP,3)-1),-1),0,255)) then exit;
  if not(IntInBounds(StrToIntDef(copye(IP,posn('.',IP,3)+1),-1),0,255)) then exit;
  result := true;
end;

function returnmonth(D: TDateTime): word;
begin
  result := StrToInt(FormatDateTime('M', D));
end;

function returnYear(D: TDateTime): word;
begin
  result := StrToIntdef(FormatDateTime('yyyy', D),0);
end;

function returnHour(D: TDateTime): word;
begin
  result := StrToIntdef(FormatDateTime('h', D),0);
end;

function returnMins(D: TDateTime): word;
begin
  result := StrToIntdef(FormatDateTime('n', D),0);
end;

function returnDay(D: TDateTime): word;
begin
  result := StrToIntdef(FormatDateTime('d', D),0);
end;

function returnMaxDay(D: TDateTime): word;
var M, Y: word;
begin
  M := returnmonth(D);
  Y := returnYear(D);
if M+1>12 then
  D:=EncodeDate(Y+1, M, 1) - 1
 else D :=EncodeDate(Y, M+1, 1) - 1;
  result := StrToIntdef(FormatDateTime('d', D),0);
end;


function SecToHMS(S: Cardinal): string;
var H, M, sec: word;
 function formatdigit(Dig:word):string;
  begin
 if dig<10 then result:='0'+IntToStr(dig)
  else result:=IntToStr(dig);
  end;
begin
  H := S div 3600;
  M := (S mod 3600) div 60;
  sec := (S mod 3600) mod 60;
  result :=format('%s:%s:%s h',[formatdigit(H),formatdigit(M),formatdigit(sec)]);
end;

function MysqlDateToStr(Dt,Fmt: string): string;
var Y,M,D,H,N,S : word;
begin
  if Dt = '0000-00-00 00:00:00' then
   begin result := 'Session Alive'; exit; end;
  if length(Dt)<19 then Dt:=Dt+'0000000000000000000';
  Y := StrToIntDEf(copy(Dt, 1, 4),1975);
  M := StrToIntdef(copy(Dt, 6, 2),0);
  D := StrToIntDEf(copy(Dt, 9, 2),0);
  H := StrToIntDEf(copy(Dt, 12, 2),0);
  N := StrToIntDEf(copy(Dt, 15, 2),0);
  S := StrToIntDEf(copy(Dt, 18, 2),0);
  result := formatdatetime(Fmt, EncodeDateTime(Y,M,D,H,N,S,0));
end;

function MysqlTimeStampToStr(Dt,Fmt: string): string;
var Y,M,D,H,N,S : word;
function fixYY(s:string):string;
begin
  if strtointdef(copy(s,1,2),-1)<75 then result:='20'+s else result:='19'+s;
end;
begin
  if Dt = '00000000000000' then
   begin result := 'Session Alive'; exit; end;
  case length(Dt) of
   14: ;
   12: fixYY(Dt);
   10: begin fixYY(Dt); Dt:=Dt+'00'; end;
    8: Dt:=Dt+'000000';
    6: begin fixYY(Dt); Dt:=Dt+'000000'; end;
    4: begin fixYY(Dt); Dt:=Dt+'01000000'; end;
    2: begin fixYY(Dt); Dt:=Dt+'0101000000'; end;
  else begin result := 'Session Alive'; exit; end;
  end;
  Y := StrToIntDEf(copy(Dt, 1, 4),1975);
  M := StrToIntdef(copy(Dt, 5, 2),0);
  D := StrToIntDEf(copy(Dt, 7, 2),0);
  H := StrToIntDEf(copy(Dt, 9, 2),0);
  N := StrToIntDEf(copy(Dt, 11, 2),0);
  S := StrToIntDEf(copy(Dt, 13, 2),0);
  result := formatdatetime(Fmt, EncodeDateTime(Y,M,D,H,N,S,0));
end;

function StartOfMonth(Dt: TDateTime): TDateTime;
var M, Y, D: word;
begin
  D := 1;
  Y := returnYear(Dt);
  M := returnmonth(Dt);
  result :=EncodeDate(Y, M, D);
end;


function StartOfyear(Dt: TDateTime): TDateTime;
var M, Y, D: word;
begin
  D := 1;
  Y := returnYear(Dt);
  M := 1;
  result :=EncodeDate(Y, M, D);
end;

function EndOfMonth(Dt: TDateTime): tDateTime;
var M, Y, D: word;
begin
  D := returnMaxDay(Dt);
  Y := returnYear(Dt);
  M := returnmonth(Dt);
  result:=EncodeDate(Y, M, D);
end;


function StrScan(const S: string; Ch: Char; StartPos: Integer): Integer;
asm
        TEST    EAX,EAX
        JE      @@qt
        PUSH    EDI
        MOV     EDI,EAX
        LEA     EAX,[ECX-1]
        MOV     ECX,[EDI-4]
        SUB     ECX,EAX
        JLE     @@m1
        PUSH    EDI
        ADD     EDI,EAX
        MOV     EAX,EDX
        POP     EDX
        REPNE   SCASB
        JNE     @@m1
        MOV     EAX,EDI
        SUB     EAX,EDX
        POP     EDI
        RET
@@m1:   POP     EDI
        XOR     EAX,EAX
@@qt:
end;

function TestByMask(const S, Mask: string; MaskChar: Char): Boolean;
asm
        TEST    EAX,EAX
        JE      @@qt2
        PUSH    EBX
        TEST    EDX,EDX
        JE      @@qt1
        MOV     EBX,[EAX-4]
        CMP     EBX,[EDX-4]
        JE      @@01
@@qt1:  XOR     EAX,EAX
        POP     EBX
@@qt2:  RET
@@01:   DEC     EBX
        JS      @@07
@@lp:   MOV     CH,BYTE PTR [EDX+EBX]
        CMP     CL,CH
        JNE     @@cm
        DEC     EBX
        JS      @@eq
        MOV     CH,BYTE PTR [EDX+EBX]
        CMP     CL,CH
        JNE     @@cm
        DEC     EBX
        JS      @@eq
        MOV     CH,BYTE PTR [EDX+EBX]
        CMP     CL,CH
        JNE     @@cm
        DEC     EBX
        JS      @@eq
        MOV     CH,BYTE PTR [EDX+EBX]
        CMP     CL,CH
        JNE     @@cm
        DEC     EBX
        JNS     @@lp
@@eq:   MOV     EAX,1
        POP     EBX
        RET
@@cm:   CMP     CH,BYTE PTR [EAX+EBX]
        JNE     @@07
        DEC     EBX
        JNS     @@lp
        MOV     EAX,1
        POP     EBX
        RET
@@07:   XOR     EAX,EAX
        POP     EBX
end;

function TestWildStr(const S, Mask: string; MaskChar, WildCard: Char): Boolean;
label
  99;
var
  L,X,X0,Q: Integer;
  P,P1,B: PChar;
  C: Char;
begin
  X := StrScan(Mask,WildCard);
  if X = 0 then
  begin
    Result := TestByMask(S,Mask,MaskChar);
    Exit;
  end;
  L := Length(S);
  P := Pointer(S);
  Result := False;
  B := Pointer(Mask);
  Q := X-1;
  if L < Q then
    Exit;
  while Q > 0 do
  begin
    C := B^;
    if (C<>MaskChar) and (C<>P^) then
      Exit;
    Dec(Q);
    Inc(B);
    Inc(P);
  end;
  Dec(L,X-1);
  repeat
    X0 := X;
    P1 := P;
    while Mask[X0] = WildCard do
      Inc(X0);
    X := StrScan(Mask,WildCard,X0);
    if X = 0 then
      Break;
  99:
    P := P1;
    B := @Mask[X0];
    Q := X-X0;
    if L < Q then
      Exit;
    while Q > 0 do
    begin
      C := B^;
      if (C<>MaskChar) and (C<>P^) then
      begin
        Inc(P1);
        Dec(L);
        goto 99;
      end;
      Dec(Q);
      Inc(B);
      Inc(P);
    end;
    Dec(L,X-X0);
  until False;
  X := Length(Mask);
  if L >= X-X0+1 then
  begin
    P := Pointer(S);
    Inc(P,Length(S)-1);
    while X >= X0 do
    begin
      C := Mask[X];
      if (C<>MaskChar) and (C<>P^) then
        Exit;
      Dec(X);
      Dec(P);
    end;
    Result := True;
  end;
end;

function TestWildText(const S, Mask: string; MaskChar, WildCard: Char): Boolean;
label
  99;
var
  L,X,X0,Q: Integer;
  P,P1,B: PChar;
  C: Char;
begin
  X := StrScan(Mask,WildCard);
  Result := False;
  if X = 0 then
  begin
    L := Length(Mask);
    if (L>0) and (L=Length(S)) then
    begin
      P := Pointer(S);
      B := Pointer(Mask);
      repeat
        C := B^;
        if (C<>MaskChar) and (C<>P^) and
            (ToUpperChars[Byte(C)]<>ToUpperChars[Byte(P^)]) then
          Exit;
        Dec(L);
        Inc(B);
        Inc(P);
      until L = 0;
      Result := True;
    end;
    Exit;
  end;
  L := Length(S);
  P := Pointer(S);
  B := Pointer(Mask);
  Q := X-1;
  if L < Q then
    Exit;
  while Q > 0 do
  begin
    C := B^;
    if (C<>MaskChar) and (C<>P^) and
        (ToUpperChars[Byte(C)]<>ToUpperChars[Byte(P^)]) then
      Exit;
    Dec(Q);
    Inc(B);
    Inc(P);
  end;
  Dec(L,X-1);
  repeat
    X0 := X;
    P1 := P;
    while Mask[X0] = WildCard do
      Inc(X0);
    X := StrScan(Mask,WildCard,X0);
    if X = 0 then
      Break;
  99:
    P := P1;
    B := @Mask[X0];
    Q := X-X0;
    if L < Q then
      Exit;
    while Q > 0 do
    begin
      C := B^;
      if (C<>MaskChar) and (C<>P^) and
        (ToUpperChars[Byte(C)]<>ToUpperChars[Byte(P^)]) then
      begin
        Inc(P1);
        Dec(L);
        goto 99;
      end;
      Dec(Q);
      Inc(B);
      Inc(P);
    end;
    Dec(L,X-X0);
  until False;
  X := Length(Mask);
  if L >= X-X0+1 then
  begin
    P := Pointer(S);
    Inc(P,Length(S)-1);
    while X >= X0 do
    begin
      C := Mask[X];
      if (C<>MaskChar) and (C<>P^) and
          (ToUpperChars[Byte(C)]<>ToUpperChars[Byte(P^)]) then
        Exit;
      Dec(X);
      Dec(P);
    end;
    Result := True;
  end;
end;

function DateToMysql(Dt:TDAteTime):string;
 begin
  result:=formatdatetime('yyyy-mm-dd hh:nn:ss',dt);

 end;

function NumInArr(num:integer;arr:array of integer):boolean;
var i:integer;
begin
 result:=false;
if length(arr)=0 then exit;
 for i:=0 to high(arr) do
  if arr[i]=num then begin
  result:=true;
  break;
  end;
end;

function ReturnPeriodBound(const PeriodStartBound:TDateTime; const PKind:TPeriodLengthKind; const Value:word; const Direction:boolean):TDateTime;
var m,y,sgn,NewMnt,NewYear,NewDay,
    valDiv12,valMod12,IfOk,IfNot:Integer;

begin
            if Direction then sgn:=1
             else sgn:=-1;
 Result:=PeriodStartBound;
 case PKind of
  plSec:   Result:=PeriodStartBound+(sgn*((Value/3600)/24));
  plMin:   Result:=PeriodStartBound+(sgn*((Value/60)/24));
  plHour:  Result:=PeriodStartBound+(sgn*(Value/24));
  plDay:   REsult:=PeriodStartBound+(sgn*Value);
  plMonth: begin
            m:=returnmonth(PeriodStartBound);
            y:=returnYear(PeriodStartBound);
            valDiv12:=Value div 12;
            valMod12:=Value mod 12;
            IfOk:=m+(sgn*valMod12);
            IfNot:=abs(12-abs(IfOk));
            if ((IfOk<1) or (IfOk>12))
                then NewMnt:=IfNot
                        else NewMnt:=IfOk;
          if ((IfOk<1) or (IfOk>12)) and (valDiv12=0)
                then  NewYear:=y+(sgn*(valDiv12+1))
                else  NewYear:=y+(sgn*valDiv12);
          NewDay:=returnDay(PeriodStartBound);
                   if returnMaxDay( EncodeDate(NewYear,NewMnt,1))<NewDay
          then NewDay:=returnMaxDay( EncodeDate(NewYear,NewMnt,1));

       result:=EncodeDateTime(NewYear,NewMnt,NewDay,0,0,0,0)
                        + frac(PeriodStartBound);
         end;
  plYear:  begin
            NewYear:=returnYear(PeriodStartBound)+ (sgn*Value);
            NewMnt:=returnmonth(PeriodStartBound);
            NewDay:=returnDay(PeriodStartBound);
            if returnMaxDay( EncodeDate(NewYear,NewMnt,1))<NewDay
            then NewDay:=returnMaxDay( EncodeDate(NewYear,NewMnt,1));
            result:=EncodeDateTime(NewYear,NewMnt,NewDay,0,0,0,0)
                        + frac(PeriodStartBound);
           end;
 end;


end;

function returnBegOfDay(const Dt:TDateTime):TDateTime;
begin
 Result:=Dt - Frac(Dt);
end;

function returnEndOfDay(const Dt:TDateTime):TDateTime;
begin
 Result:=(Dt+1 - Frac(Dt+1))-(1/3600)/24;
end;


procedure returnweeks(const pFrom,pTo: TDateTime ;var ResArr:TWeekArr;  Fmt:string  = '%d_%d');
var k,i,b,e:integer;
   y1,y2:word;
begin
 y1:=returnYear(pFrom);
 y2:=returnYear(pTo);
 b:= WeekOfTheYear(pFrom, y1) ;
 e:= WeekOfTheYear(pTo, y2);
 setlength(ResArr,0);
 if y2=y1 then begin
  for i:=b to e do begin
   setlength(ResArr,length(ResArr)+1);
   ResArr[high(ResArr)]:=format(Fmt,[y1,i]);
  end;
 end
 else begin
  for i:=b to 53 do begin
   setlength(ResArr,length(ResArr)+1);
   ResArr[high(ResArr)]:=format(Fmt,[y1,i]);
  end;
  if y2-y1>1 then
   for k:=1 to y2-y1-1 do
    for i:=1 to 53 do begin
     setlength(ResArr,length(ResArr)+1);
     ResArr[high(ResArr)]:=format(Fmt,[y1+k,i]);
    end;
  for i:=1 to e do begin
   setlength(ResArr,length(ResArr)+1);
   ResArr[high(ResArr)]:=format(Fmt,[y2,i]);
  end;
 end;
end;

function GetInetFile(const fileURL, AppName,
                FileName: String; Terminated:pboolean; OnProgress:TNotifyEvent; OnProgressSize:TNotifyInteger): boolean;
const BufferSize = 1024;
var
  hSession, hURL: HInternet;
  Buffer: array[1..BufferSize] of Byte;
  BufferLen,transfered,fsize: DWORD;
  f: File;
  sAppName: string;
begin
  if (Terminated<>nil) then Terminated^:=false;
 Result:=False;
 fsize:=0;
 if result then else;
 sAppName := AppName;
 hSession := InternetOpen(PChar(sAppName),
                INTERNET_OPEN_TYPE_PRECONFIG,
               nil, nil, 0);
 try
  hURL := InternetOpenURL(hSession,
            PChar(fileURL),
            nil,0,0,0);
  try
   AssignFile(f, FileName);
   Rewrite(f,1);
  repeat
    if (Terminated<>nil) and (Terminated^) then exit;
    if assigned(OnProgress)
      then OnProgress(nil);
    InternetReadFile(hURL, @Buffer,
                     SizeOf(Buffer), BufferLen);
   try
    BlockWrite(f, Buffer, BufferLen,transfered);
   except
    on EInOutError do exit;
   end;
    if transfered<>BufferLen then exit;
    inc(fsize,BufferLen);
    if assigned(OnProgressSize) then OnProgressSize(nil,fsize);
   until BufferLen = 0;
   CloseFile(f);
   Result:=True;
  finally
   InternetCloseHandle(hURL)
  end
 finally
  InternetCloseHandle(hSession)
 end;
end;

function MakeProgressString(PrChar:Char; CurrentState:string; MaxCount:word):string;
var cnt:integer;
begin
 cnt:=CountStr(PrChar,CurrentState);
 if cnt<=0 then begin result:=PrChar; exit; end;
 if cnt<MaxCount then
  Result:=CurrentState+PrChar
 else Result:=PrChar;
end;

function MakeRotatingSplash(CurrentState:string):string;
begin
  if length(CurrentState)<1 then result:='\' else
  case CurrentState[1] of
   '\' : Result:='|';
   '|' : Result:='/';
   '/' : Result:='-';
  else   Result:='\';
  end;
end;

procedure SetParamHeaders(UseParamHeadersA:boolean;ParamHeadersA:string;HeaderDelimiter:char);
var i:integer;
    s:string;
procedure AddHeader(s:string);
begin
  SetLength(ParamHeaders,length(ParamHeaders)+1);
  ParamHeaders[high(ParamHeaders)]:=s;
end;
begin
  UseParamHeaders:=UseParamHeadersA;
  if ParamHeadersA='Don''t Change' then exit;
  SetLength(ParamHeaders,0);
  if CountStr(HeaderDelimiter,ParamHeadersA)=0 then
   begin
    if ParamHeadersA='' then AddHeader('')
                        else AddHeader(ParamHeadersA);
    exit;
   end;
  AddHeader(copy(ParamHeadersA,1,pos(HeaderDelimiter,ParamHeadersA)-1));
  for i:=1 to CountStr(HeaderDelimiter,ParamHeadersA)-1 do
   AddHeader(copye(ParamHeadersA,posn(HeaderDelimiter,ParamHeadersA,i)+1,posn(HeaderDelimiter,ParamHeadersA,i+1)-1));
  s:=copye(ParamHeadersA,posn(HeaderDelimiter,ParamHeadersA,CountStr(HeaderDelimiter,ParamHeadersA))+1);
  if s<>'' then AddHeader(s);
end;

function GetParamValue(OptionName:string;HasHaveValue:boolean;ValueSeparator:char;TRUEStirng:string;
                        FALSEString:string;ErrorString:string;UseThisParamHeader:string):string;
var i:integer;
    s:string;
    b,res:boolean;

function Param(n:integer):string;
var i:integer;
begin
  if UseThisParamHeader<>'Use Global ParamHeaders' then
   if pos(UseThisParamHeader,paramstr(n))=1 then result:=copye(paramstr(n),length(UseThisParamHeader)+1)
                                            else result:=''
  else if not UseParamHeaders then result:=paramstr(n)
  else
   begin
     for i:=0 to high(ParamHeaders) do
      if pos(ParamHeaders[i],paramstr(n))=1 then begin result:=copye(paramstr(n),length(ParamHeaders[i])+1); exit; end;
     result:='';
   end;
end;
begin
  if length(ParamHeaders)=0 then SetParamHeaders(true,'/;-');
  if OptionName='' then begin Result:=ErrorString; exit; end;
  s:=AnsiUpperCase(OptionName);
  b:=HasHaveValue and (ValueSeparator<>' ');
  res:=false;
  for i:=1 to ParamCount do
   if b then if pos(s,AnsiUpperCase(Param(i)))=1 then
              if (Length(OptionName)=Length(Param(i))) or (pos(s+ValueSeparator,AnsiUpperCase(Param(i))+ValueSeparator)=1)
               then begin res:=true; break; end else else
        else if s=AnsiUpperCase(Param(i)) then begin res:=true; break; end;
  if res then
   if HasHaveValue then
    if ValueSeparator=' ' then
     if i+1>ParamCount then Result:=ErrorString
                       else Result:=ParamStr(i+1)
    else
     if pos(s+ValueSeparator,AnsiUpperCase(Param(i))+ValueSeparator)=1
      then Result:=copye(Param(i),length(OptionName)+2)
      else Result:=ErrorString
   else Result:=TRUEStirng
  else Result:=FALSEString;
end;

function UpdateEXEErrorMessage(ShowMessageDialog:boolean):string;
begin
  case UpdateEXEError of
   0 : Result:='No Errors';
   1 : Result:='Already exists process with UpdateEXE functioning';
   2 : Result:='Can''t create copy of current EXE';
   3 : Result:='Can''t execute the copy of current EXE';
   10: Result:='Exename paramter is missing';
   11,15: Result:='Other process with UpdateEXE functioning exists and does not close for the Time Limit';
   12: Result:='Can''t delete old exe';
   13: Result:='Newexe paramter is missing';
   14: Result:='Oldexe paramter is missing';
   16: Result:='New exe does not exists';
   17: Result:='Can''t delete old exe';
   18: Result:='Can''t copy new exe to old exe';
   19: Result:='Can''t execute new exe';
  else Result:='Unknown Error';
  end;
  if ShowMessageDialog then MessageDlg(Result+'.', mtError, [mbOK], 0);
end;

procedure UpdateEXE(NewExe:string;CurExeNewName:string;DeleteCurExe:boolean;DontHalt:boolean);
var hand:THandle;
    s:string;
begin
  hand:=CreateMutex(nil, false, 'UpdateEXEHolder');
  if GetLastError=ERROR_ALREADY_EXISTS then
   begin UpdateEXEError:=1; exit; end; //already exists process with UpdateEXE
  if not(CopyFile(pchar(ParamStr(0)),pchar(CurExeNewName),false)) then
   begin UpdateEXEError:=2; exit; end; //can't copy curexe to curnewnameexe
  s:='/updateexe /newexe "'+NewExe+'" /oldexe "'+paramstr(0)+'"';
  if DeleteCurExe then s:=s+' /deleteexe';
  if ShellExecute(0,'open',pchar(CurExeNewName),pchar(s),pchar(ExtractFilePath(CurExeNewName)),SW_NORMAL)<=32 then
   begin CloseHandle(hand); UpdateEXEError:=3; exit; end; //can't execute curnewnameexe
  UpdateEXEError:=0; //everything is OK
  if not(DontHalt) then halt(0);
end;

procedure CheckUpdateEXE(MillisecondsToWait:Cardinal; HaltIfFailed:boolean);
var del:boolean;
    hand:THandle;
    newexe,oldexe:string;
function WaitMutexToEnd:boolean;
var ti:Cardinal;
begin
  ti:=GetTickCount;
  while (GetTickCount-ti)<=MillisecondsToWait do
   begin
     hand:=CreateMutex(nil, false, 'UpdateEXEHolder');
     if GetLastError=ERROR_ALREADY_EXISTS then CloseHandle(hand)
      else begin result:=true; exit; end;
   end;
  result:=false;
end;
procedure DoErr(Code:integer);
begin
  UpdateEXEError:=Code;
  if HaltIfFailed then halt(0)
   else if hand<>0 then CloseHandle(hand);
end;
begin
  if GetParamValue('updateexe',false,' ','1','0','0','/')='0' then
   if GetParamValue('deleteexe',false,' ','1','0','0','/')='0' then exit
   else del:=true
  else del:=false;
  if del then
   begin
     oldexe:=GetParamValue('exename',true,' ','1','-1','-1','/');
     if oldexe='-1' then
      begin UpdateEXEError:=10; exit; end; //exename paramter is missing
     if not WaitMutexToEnd then
      begin UpdateEXEError:=11; exit; end; //mutex not closed
     if not(DeleteFile(oldexe)) then UpdateEXEError:=12 //can't delete exename
                           else UpdateEXEError:=0; //everything is OK
     CloseHandle(hand);
   end
  else
   begin
     newexe:=GetParamValue('newexe',true,' ','1','-1','-1','/');
     if newexe='-1' then
              begin DoErr(13); exit; end; //newexe paramter is missing
     oldexe:=GetParamValue('oldexe',true,' ','1','-1','-1','/');
     if oldexe='-1' then
              begin DoErr(14); exit; end; //oldexe paramter is missing
     if not WaitMutexToEnd then
              begin DoErr(15); exit; end; //mutex not closed
     if not(FileExists(newexe)) then
              begin DoErr(16); exit; end; //newexe does not exists
     if FileExists(oldexe) then
      if not(DeleteFile(oldexe)) then
              begin DoErr(17); exit; end; //can't delete oldexe
     if not(MoveFile(pchar(newexe),pchar(oldexe))) then
              begin DoErr(18); exit; end; //can't copy oldexe to newexe
     if GetParamValue('deleteexe')='0' then newexe:=''
                                       else newexe:='/deleteexe /exename "'+ParamStr(0)+'"';
     if ShellExecute(0,'open',pchar(oldexe),pchar(newexe),pchar(ExtractFilePath(oldexe)),SW_NORMAL)<=32 then
              begin DoErr(19); exit; end; //can't execute newexe
     halt(0);
   end;
end;

function ReplaceStr(const SubstrToRaplce,RaplaceStr,Str:string):string;
var s:string;
begin
  s:=Str;
  result:='';
  while pos(SubstrToRaplce,s)>0 do
   begin
     result:=result+copy(s,1,pos(SubstrToRaplce,s)-1);
     result:=result+RaplaceStr;
     s:=copye(s,pos(SubstrToRaplce,s)+length(SubstrToRaplce));
   end;
  result:=result+s;
end;

function SaveLoadFromReg(const RegKey,Name :string; Action:TRegistryAction;
                                ValueType:TRegistryValueType;CanCreate:boolean;
                                                         var Value:Variant):boolean;
var reg:TRegistry;
begin
  reg:=TRegistry.Create;
 try
  result:=(reg.KeyExists(RegKey));
  reg.OpenKey(RegKey,CanCreate);
  reg.LazyWrite:=false;
  result:=result and (reg.ValueExists(Name));
  if Action=raCheck then exit;

 if Action=raRead then
   case ValueType of
    rvtBool:if reg.ValueExists(Name)
                 then Value:=reg.ReadBool(Name)
                     else Value:=false;
    rvtCurrency:if reg.ValueExists(Name)
                 then Value:=reg.ReadCurrency(Name)
                     else Value:=-1;
    rvtDate:if reg.ValueExists(Name)
                 then Value:=reg.ReadDate(Name)
                     else Value:=-1;
    rvtDateTime:if reg.ValueExists(Name)
                 then Value:=reg.ReadDateTime(Name)
                     else Value:=-1;
    rvtFloat:if reg.ValueExists(Name)
                 then Value:=reg.ReadFloat(Name)
                     else Value:=-1;
    rvtInteger:if reg.ValueExists(Name)
                 then Value:=reg.ReadInteger(Name)
                     else Value:=-1;
    rvtString:if reg.ValueExists(Name)
                 then Value:=reg.ReadString(Name)
                     else Value:='';
    rvtTime:if reg.ValueExists(Name)
                 then Value:=reg.ReadTime(Name)
                     else Value:=-1;
   else Value:=-1;
  end;

  if Action=raWrite then
   case ValueType of
    rvtBool:if reg.KeyExists(RegKey)
                then reg.WriteBool(Name,Value);

    rvtCurrency:if reg.KeyExists(RegKey)
                then reg.WriteCurrency(Name,Value);
    rvtDate:if reg.KeyExists(RegKey)
                then reg.WriteDate(Name,Value);
    rvtDateTime:if reg.KeyExists(RegKey)
                then reg.WriteDateTime(Name,Value);
    rvtFloat:if reg.KeyExists(RegKey)
                then reg.WriteFloat(Name,Value);
    rvtInteger:if reg.KeyExists(RegKey)
                then reg.WriteInteger(Name,Value);
    rvtString:if reg.KeyExists(RegKey)
                then reg.WriteString(Name,Value);
    rvtTime:if reg.KeyExists(RegKey)
                then reg.WriteTime(Name,Value);
  end;
  reg.CloseKey;
 finally
  reg.free;
 end;
end;

function ExecLink(Link:string):boolean;
begin
  result:=true;
  if pos('mailto:',Link)=1 then ShellExecute(GetDesktopWindow(), 'Open', PChar(Trim(Link)), nil, nil, SW_SHOWNORMAL) else
   if ShellExecute(GetDesktopWindow(),PChar('open'),PChar('netscape.exe'),PChar(Trim(Link)),nil,SW_NORMAL) <= 32 then
    if ShellExecute(GetDesktopWindow(),PChar('open'),PChar('iexplore.exe'),PChar(Trim(Link)),nil,SW_NORMAL) <= 32 then
     if ShellExecute(GetDesktopWindow(),PChar('open'),PChar(Trim(Link)),PChar(''),nil,SW_NORMAL) <= 32 then
      begin
        if OnExecLinkErrorShowMessage<>'' then
         ShowMessage(OnExecLinkErrorShowMessage);
        result:=false;
      end;
end;

procedure FailMsg(Id,Msg:string);
begin
 MessageDlg(Id+': '+ trim(Msg),mtError,[mbOk],0);

end;
function idxInArr(num:integer;arr:array of integer):integer;
var i:integer;
begin
 result:=-1;
if length(arr)=0 then exit;
 for i:=0 to high(arr) do
  if arr[i]=num then begin
  result:=i;
  break;
  end;
end;

function numCntInArray(num:integer;arr:array of integer):integer;
var i,cntr:integer;
begin
 result:=0;
if length(arr)=0 then exit;
 cntr:=0;
 for i:=0 to high(arr) do
  if arr[i]=num then inc(cntr);

 result:=cntr;
end;
function findNotInArr(arr:array of integer;Min,Max,IfFailed :integer):integer;
var num:integer;
begin
 result:=IfFailed;
 num:=Min;
 while (IntInBounds(num,Min,Max))
  and (NumInArr(num,arr)) do
   inc(num);
 if (IntInBounds(num,Min,Max))
  and (not NumInArr(num,arr))
   then Result:=num;
end;

end.

